<script setup lang="ts">
import { onMounted, ref } from "vue";
import { useQuasar } from "quasar";
import type { QTableProps } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { useSpecialTimeStore } from "@/modules/09_leave/stores/SpecialTimeStore";
import { checkPermission } from "@/utils/permissions";
import { usePagination } from "@/composables/usePagination";

import type { DataDateMonthObject } from "@/modules/09_leave/interface/request/specialTime";
import type { DataSpecialTime } from "@/modules/09_leave/interface/index/Main";

import DialogReason from "@/components/Dialogs/PopupReason.vue";
import DialogApprove from "@/modules/09_leave/components/04_SpecialTime/DialogApprove.vue";

const $q = useQuasar(); // show dialog
const mixin = useCounterMixin();
const store = useSpecialTimeStore();
const {
  hideLoader,
  monthYear2Thai,
  messageError,
  showLoader,
  success,
  date2Thai,
  dialogConfirm,
} = mixin;
const { pagination, params, onRequest } = usePagination("", fetchData);

const emit = defineEmits(["update:change-page"]);

const toDay = ref<Date>(new Date());
const monthToday = toDay.value.getMonth();
const yearToday = toDay.value.getFullYear();

const month = ref<number>(monthToday + 1);
const year = ref<number>(yearToday);
const description = ref<string>("");

/**ตัวแปรที่ใช้ */
const modalUnapprove = ref<boolean>(false);
const modalApprove = ref<boolean>(false);
const detailData = ref<DataSpecialTime>();
const editCheck = ref<string>("");
const dialogTitle = ref<string>("");
const dialogDesc = ref<string>("");
const name = ref<string>("");
const id = ref<string>("");
const dateDialog = ref<string>("");
const dateFixDialog = ref<string>("");
const dateYear = ref<number>(new Date().getFullYear());

/** Function Date */
const dateMonth = ref<DataDateMonthObject>({
  month: new Date().getMonth(),
  year: new Date().getFullYear(),
});

// ค้นหาในตาราง
const filterKeyword = ref<string>("");
const rows = ref<DataSpecialTime[]>([]);
const visibleColumns = ref<String[]>([
  "no",
  "fullName",
  "createdAt",
  "checkDate",
  "startTimeMorning",
  "startTimeAfternoon",
  "description",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "center",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "fullName",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "fullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่ยื่นเรื่อง",
    sortable: true,
    field: "date",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "checkDate",
    align: "left",
    label: "วันที่ขอแก้ไข",
    sortable: true,
    field: "dateFix",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "startTimeMorning",
    align: "left",
    label: "ช่วงเช้า",
    sortable: false,
    field: "timeMorning",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "startTimeAfternoon",
    align: "left",
    label: "ช่วงบ่าย",
    sortable: false,
    field: "timeAfternoon",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "description",
    align: "left",
    label: "เหตุผลการขอลงเวลาพิเศษ",
    sortable: true,
    field: "description",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);

/** ฟังก์ชั่นเรียกดูข้อมูลรายการลงเวลากรณีพิเศษ */
async function fetchData() {
  showLoader();
  await http
    .get(config.API.specialTime(), {
      params: {
        ...params.value,
        year: year.value,
        month: month.value,
        keyword: filterKeyword.value.trim(),
      },
    })
    .then(async (res) => {
      const result = await res.data.result;
      pagination.value.rowsNumber = result.total;
      if (result.data.length > 0) {
        rows.value = result.data.map((e: DataSpecialTime) => ({
          ...e,
          date: date2Thai(new Date(e.createdAt), false, true),
          dateFix: date2Thai(new Date(e.checkDate)),
          timeMorning:
            e.startTimeMorning == null
              ? "-"
              : e.checkInEdit == true
              ? e.startTimeMorning + " - " + e.endTimeMorning
              : "-",
          timeAfternoon:
            e.startTimeAfternoon == null
              ? "-"
              : e.checkOutEdit == true
              ? e.startTimeAfternoon + " - " + e.endTimeAfternoon
              : "-",
          checkIn: e.checkInTime,
          checkOut: e.checkOutTime,
          checkInStatus: store.convertStatus(e.checkInStatus),
          checkOutStatus: store.convertStatus(e.checkOutStatus),
        }));
      } else {
        rows.value = [];
      }
    })
    .catch((e) => {
      rows.value = [];
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชั่นไม่อนุมัติ
 * @param fullname ชื่อ
 * @param personId personId
 */
async function unapprove(fullname: string, personId: string) {
  id.value = personId;
  dialogTitle.value = " ไม่อนุมัติคำขอ"; // + fullname;
  name.value = fullname;
  modalUnapprove.value = true;
}

/**
 *  ฟังก์ชั่นอนุมัติ
 * @param data ข้อมูล
 */
function openModal(data: DataSpecialTime) {
  id.value = data.id;
  dateDialog.value = data.date;
  description.value = data.description;
  dateFixDialog.value = data.dateFix;
  editCheck.value = data.status;
  detailData.value = data;
  modalApprove.value = true;
}

/** ฟังก์ชั่นปิด Dialog */
function closeDialog() {
  modalUnapprove.value = false;
  modalApprove.value = false;
  description.value = "";
  editCheck.value = "PENDING";
}

/**
 * ฟังก์ชั่นบันทึกข้อมูลไม่อนุมัติ
 * @param reason เหตุผลที่ไม่อนุมัติ
 */
async function clickSave(reason: string) {
  dialogConfirm($q, async () => {
    showLoader();
    await http
      .put(config.API.specialTimeReject(id.value), {
        reason: reason,
      })
      .then(async () => {
        await fetchData();
        success($q, "บันทึกข้อมูลสำเร็จ");
        modalUnapprove.value = false;
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ดึงข้อมูลตามปี
 * @param e ปี
 */
async function updateMonth(e: DataDateMonthObject) {
  if (e != null) {
    dateYear.value = e.year;
    dateYear.value = year.value;
    month.value = dateMonth.value.month + 1;
    year.value = dateMonth.value.year;
    onSearchData();
  }
}

//แปลงเดือนเป็นไทย
function monthYearThai(val: DataDateMonthObject) {
  if (val == null) return "";
  else return monthYear2Thai(val.month, val.year);
}

/** ฟังก์ชั่นค้นหาข้อมูล */
function onSearchData() {
  pagination.value.page = 1;
  fetchData();
}

/**Hook */
onMounted(async () => {
  //อัพเดทเป็นวันปัจจุบันเมื่อเข้าหน้านี้
  const toDay = ref<Date>(new Date());
  const monthToday = toDay.value.getMonth();
  const yearToday = toDay.value.getFullYear();
  month.value = monthToday + 1;
  year.value = yearToday;
  await fetchData();
});
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    รายการลงเวลากรณีพิเศษ
  </div>

  <q-card flat bordered class="col-12 q-pa-md">
    <div class="row col-12 q-col-gutter-sm q-mb-sm">
      <div class="col-xs-12 col-sm-3 col-md-2">
        <datepicker
          v-model="dateMonth"
          :locale="'th'"
          autoApply
          month-picker
          :enableTimePicker="false"
          @update:modelValue="updateMonth"
        >
          <template #year="{ year }">{{ year + 543 }}</template>
          <template #year-overlay-value="{ value }">{{
            parseInt(value + 543)
          }}</template>
          <template #trigger>
            <q-input
              :model-value="monthYearThai(dateMonth)"
              dense
              outlined
              hide-bottom-space
            >
              <template v-slot:prepend>
                <q-icon
                  name="event"
                  class="cursor-pointer"
                  style="color: var(--q-primary)"
                >
                </q-icon>
              </template>
            </q-input>
          </template>
        </datepicker>
      </div>

      <q-space />
      <div class="col-xs-12 col-sm-3 col-md-2">
        <q-input
          standout
          dense
          v-model="filterKeyword"
          outlined
          placeholder="ค้นหาชื่อ-นามสกุล"
          @keydown.enter.prevent="onSearchData()"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </div>

      <div class="col-xs-12 col-sm-3 col-md-2">
        <q-select
          v-model="visibleColumns"
          multiple
          outlined
          dense
          options-dense
          :display-value="$q.lang.table.columns"
          emit-value
          map-options
          :options="columns"
          option-value="name"
        />
      </div>
    </div>
    <div class="col-12">
      <p-table
        :columns="columns"
        :rows="rows"
        row-key="id"
        flat
        bordered
        :paging="false"
        dense
        :visible-columns="visibleColumns"
        :rows-per-page-options="[10, 25, 50, 100]"
        v-model:pagination="pagination"
        @request="onRequest"
      >
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th auto-width />
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
          </q-tr>
        </template>
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td auto-width class="text-right">
              <q-btn
                v-if="
                  props.row.status == 'PENDING' &&
                  checkPermission($route)?.attrIsUpdate &&
                  checkPermission($route)?.attrIsGet
                "
                color="orange"
                class="q-px-md"
                dense
                unelevated
                @click="unapprove(props.row.fullName, props.row.id)"
                >ไม่อนุมัติ</q-btn
              >
              <q-btn
                v-if="
                  props.row.status == 'PENDING' &&
                  checkPermission($route)?.attrIsUpdate &&
                  checkPermission($route)?.attrIsGet
                "
                color="primary"
                class="q-px-md q-ml-sm"
                dense
                unelevated
                @click="openModal(props.row)"
              >
                อนุมัติ
              </q-btn>

              <q-badge
                v-if="props.row.status == 'APPROVE'"
                rounded
                outline
                color="green"
                label="อนุมัติ"
              />
              <q-badge
                v-if="props.row.status == 'REJECT'"
                rounded
                outline
                color="red"
                label="ไม่อนุมัติ"
              />
            </q-td>
            <q-td v-for="col in props.cols" :key="col.name" :props="props">
              <div v-if="col.name == 'no'">
                {{ props.rowIndex + 1 }}
              </div>
              <div
                v-else-if="col.name === 'description'"
                class="table_ellipsis"
              >
                {{ col.value ?? "-" }}
              </div>
              <div v-else>
                {{ col.value ?? "-" }}
              </div>
            </q-td>
          </q-tr>
        </template>
      </p-table>
    </div>
  </q-card>

  <DialogReason
    v-model:modal="modalUnapprove"
    :title="dialogTitle"
    :desc="dialogDesc"
    label="เหตุผล"
    :savaForm="clickSave"
  />

  <DialogApprove
    :modal="modalApprove"
    :closeDialog="closeDialog"
    :date="dateDialog"
    :dateFix="dateFixDialog"
    :id="id"
    :description="description"
    :editCheck="editCheck"
    :detailData="detailData"
    :fetch-data="fetchData"
  />
</template>

<style></style>
